SALVAGESERVER(8)

NAME
salvageserver - Initializes the Salvageserver component of the dafs process

SYNOPSIS
salvageserver [initcmd] [-partition <name of partition to salvage>]
    [-volumeid <volume id to salvage>] [-debug] [-nowrite]
    [-inodes] [-force] [-oktozap] [-rootinodes]
    [-salvagedirs] [-blockreads]
    [-parallel <# of max parallel partition salvaging>]
    [-tmpdir <name of dir to place tmp files>]
    [-orphans (ignore | remove | attach)]
    [-syslog]
    [-syslogfacility <Syslog facility number to use>]
    [-client] [-help]

DESCRIPTION
In its typical mode of operation, the salvageserver is a daemon process responsible for salvaging volumes. It is a component of the "dafs" process type. In the conventional configuration, its binary file is located in the /usr/lib/openafs directory on a file server machine.

The Salvageserver daemon is responsible for scheduling and executing volume salvage operations on behalf of client processes. The fileserver acts as the primary salvageserver client: any failed volume attach operation results in a salvageserver scheduling request. The salvageserver also accepts periodic volume activity messages in order to update its salvage request priority queue. Other clients of the salvageserver daemon include the salvsync-debug utility, and the salvageserver command itself by passing the -client flag.

The salvage operations performed on vice partition data are nearly identical to those performed by the standalone Salvager command. The key differences between the two commands are:

•   The Salvageserver is a daemon process which runs concurrently with the fileserver. In contrast, the Salvager is a stand-alone application which is invoked when the fileserver and volserver are not running.

•   The Salvageserver is incapable of performing whole partition salvage operations; it operates at volume group granularity.

The Salvageserver normally creates new inodes as it repairs damage. If the partition is so full that there is no room for new inodes, use the -nowrite argument to bringing undamaged volumes online without attempting to salvage damaged volumes. Then use the vos move command to move one or more of the undamaged volumes to other partitions, freeing up the space that the Salvageserver needs to create new inodes.

By default, multiple Salvageserver subprocesses run in parallel: one for each volume group. By default, four concurrent salvage operations are permitted. You may alter this default by providing a positive integer value for the -parallel argument. The maximum permitted value is 32 concurrent salvageserver subprocesses.

By default, the salvageserver enables a heuristic which attempts to stop disk head thrashing by concurrent salvageserver subprocesses. Unfortunately, this heuristic significantly degrades performance in many cases. In at least the following environments, passing the "all" string to the -parallel argument is strongly encouraged:

•   On NAMEI fileservers

•   When a vice partition is backed by multiple disks (e.g. RAID)

•   When a vice partition is backed by SAN-attached storage, LVM, or some other form of storage virtualization which would cause unix device id numbers to be unpredictable.

The Salvageserver creates temporary files as it runs, by default writing them to the partition it is salvaging. The number of files can be quite large, and if the partition is too full to accommodate them, the Salvageserver terminates without completing the salvage operation (it always removes the temporary files before exiting). Other Salvageserver subprocesses running at the same time continue until they finish salvaging all other partitions where there is enough disk space for temporary files. To complete the interrupted salvage, reissue the command against the appropriate partitions, adding the -tmpdir argument to redirect the temporary files to a local disk directory that has enough space.

The -orphans argument controls how the Salvageserver handles orphaned files and directories that it finds on server partitions it is salvaging. An orphaned element is completely inaccessible because it is not referenced by the vnode of any directory that can act as its parent (is higher in the filespace). Orphaned objects occupy space on the server partition, but do not count against the volume's quota.

This command does not use the syntax conventions of the AFS command suites. Provide the command name and all option names in full.

OPTIONS

[initcmd]
    Accommodates the command's use of the AFS command parser, and is optional.

-partition <name of partition to salvage>
    Specifies the name of the partition to salvage. Specify the full partition name using the form /vicepx or /vicepxx. Omit this argument to salvage every partition on the file server machine.

-volumeid <volume id to salvage>
    Specifies the volume ID of a specific read/write volume to salvage. The -partition argument must be provided along with this one and specify the volume's actual site.

-debug
    This flag should be considered deprecated. Its primary purpose was to disable forking and parallelization of the Salvager so that log messages were not interleaved. Due to the manner in which /var/log/openafs/SalsrvLog is written, log messages from subprocesses are never interleaved; the entire log for a volume group salvage is appended to the master log as one atomic transaction.

-nowrite
    Brings all undamaged volumes online without attempting to salvage any damaged volumes.

-inodes
    Records in the /var/log/openafs/SalsrvLog file a list of all AFS inodes that the Salvageserver modified.

-force
    Inspects all volumes for corruption, not just those that are marked as having been active when a crash occurred.

-oktozap
    Removes a volume that is so damaged that even issuing the vos zap command with the -force flag is ineffective. Combine it with the -partition and -volumeid arguments to identify the volume to remove. Using this flag will destroy data that cannot be read, so use only with caution and when you're certain that nothing in that volume is still needed.

-rootinodes
    Records in the /var/log/openafs/SalsrvLog file a list of all AFS inodes owned by the local superuser "root".

-salvagedirs
    Salvages entire directory structures, even if they do not appear to be damaged. By default, the Salvageserver salvages a directory only if it is flagged as corrupted.

-blockreads
    Forces the Salvageserver to read a partition one disk block (512 bytes) at a time and to skip any blocks that are too badly damaged to be salvaged. This allows it to salvage as many volumes as possible. By default, the Salvageserver reads large disk blocks, which can cause it to exit prematurely if it encounters disk errors. Use this flag if the partition to be salvaged has disk errors.

-parallel <# of max parallel partition salvaging>
    Specifies the maximum number of Salvageserver subprocesses to run in parallel. Provide one of three values:

    •   An integer from the range 1 to 32. A value of 1 means that a single Salvageserver subprocess salvages the volume groups sequentially. The disk partition heuristic (see above) based upon unix device ids is enabled.

    •   The disk partition heuristic (see above) based upon unix device ids is disabled.

    •   The string "all" followed immediately (with no intervening space) by an integer from the range 1 to 32, to run the specified number of Salvageserver subprocesses in parallel on volume groups. The disk partition heuristic (see above) based upon unix device ids is disabled.

    If this argument is omitted, up to four Salvageserver subprocesses run in parallel.

-tmpdir <name of dir to place tmp files>
    Names a local disk directory in which the Salvageserver places the temporary files it creates during a salvage operation, instead of writing them to the partition being salvaged (the default). If the Salvageserver cannot write to the specified directory, it attempts to write to the partition being salvaged.

-orphans (ignore | remove | attach)
    Controls how the Salvageserver handles orphaned files and directories. Choose one of the following three values:

    ignore
        Leaves the orphaned objects on the disk, but prints a message to the /var/log/openafs/SalsrvLog file reporting how many orphans were found and the approximate number of kilobytes they are consuming. This is the default if the -orphans argument is omitted.

    remove
        Removes the orphaned objects, and prints a message to the /var/log/openafs/SalsrvLog file reporting how many orphans were removed and the approximate number of kilobytes they were consuming.

    attach
        Attaches the orphaned objects by creating a reference to them in the vnode of the volume's root directory. Since each object's actual name is now lost, the Salvageserver assigns each one a name of the following form:

        "__ORPHANFILE__.index" for files.
        "__ORPHANDIR__.index" for directories.

        where index is a two-digit number that uniquely identifies each object. The orphans are charged against the volume's quota and appear in the output of the ls command issued against the volume's root directory.

-syslog
    Specifies that logging output should go to syslog instead of the log file.

-syslogfacility <Syslog facility number to use>
    Specify to which facility log messages should be sent when -syslog is given.

-client
    Salvageserver runs in client Mode. The requested volume on the requested partition will be scheduled for salvaging by the Salvageserver daemon.

-logfile <log file>
    Sets the file to use for server logging. If logfile is not specified and no other logging options are supplied, this will be /var/log/openafs/SalsrvLog. Note that this option is intended for debugging and testing purposes. Changing the location of the log file from the command line may result in undesirable interactions with tools such as bos.

-help
    Prints the online help for this command. All other valid options are ignored.

EXAMPLES
The following command instructs the Salvageserver to schedule the salvage of the volume with volume ID 258347486 on /vicepg on the local machine.

   % /usr/lib/openafs/salvageserver -partition /vicepg -volumeid 258347486 -client

PRIVILEGE REQUIRED
To issue the command at the shell prompt, the issuer must be logged in as the local superuser "root".

SEE ALSO
BosConfig(5), SalvageLog(5), salvager(8), bos_create(8), bos_getlog(8), bos_salvage(8), vos_move(1)

COPYRIGHT
IBM Corporation 2000. <http://www.ibm.com/> All Rights Reserved. Sine Nomine Associates 2008. All Rights Reserved.

This documentation is covered by the IBM Public License Version 1.0. It was converted from HTML to POD by software written by Chas Williams and Russ Allbery, based on work by Alf Wachsmann and Elizabeth Cassell. This document was adapted from the Salvager POD documentation.